//+------------------------------------------------------------------+
//|                                   STPcloseTicket_JMACDSample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define MAGICMA 1361002
extern double TakeProfit = 21;
extern double StopLoss = 14;
extern double Lots = 0.1;
extern double TrailingStop = 30;
extern double MACDOpenLevel=3;
extern double MACDCloseLevel=2;
extern double MATrendPeriod=26;
extern double ma                 =21; 
extern double maa                =24;
double                           sto;
double                           rsi;
extern double adxc               =7;
extern double adx                =21;
extern double adxx               =50;
extern double F                  = 13;
extern double F2                 = 21;
extern double F3                 = 50;
extern double vals               = 5;
extern double vall               = -5;
double val;
double val2;
double val3;
double val1;
double val21;
double val31;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double MacdCurrent, MacdPrevious, SignalCurrent;
   double SignalPrevious, MaCurrent, MaPrevious;double xa;
   double xb;
   double xc;
   double xsp;
   double xxa;
   double xxb;
   double xxc;
   double xxsp;
   double cci;    
   int cnt, ticket, total;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables
   //---- get Moving Average 
   ma=iMA(NULL,0,21,0,MODE_LWMA,PRICE_OPEN,0);
   maa=iMA(NULL,0,24,3,MODE_LWMA,PRICE_WEIGHTED,3);
   adxc=iADX(NULL,0,7,PRICE_WEIGHTED,MODE_OPEN,0);
   adx=iADX(NULL,0,14,PRICE_WEIGHTED,MODE_OPEN,0);
   adxx=iADX(NULL,0,21,PRICE_HIGH,MODE_MAIN,1);
   sto=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_OPEN,0);
   rsi=iRSI(NULL,0,4,PRICE_OPEN,0);
   val=iForce(NULL,0,F,MODE_SMA,PRICE_OPEN,0);
   val2=iForce(NULL,0,F2,MODE_SMA,PRICE_OPEN,0);
   val3=iForce(NULL,0,F3,MODE_SMA,PRICE_OPEN,0);
   val1=iForce(NULL,0,F,MODE_SMA,PRICE_CLOSE,1);
   val21=iForce(NULL,0,F2,MODE_SMA,PRICE_CLOSE,1);
   val31=iForce(NULL,0,F3,MODE_SMA,PRICE_CLOSE,1); 
  
//----Check for New Orders Signals 
  
   sto=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
   rsi=iRSI(NULL,0,4,PRICE_CLOSE,0);
 
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if ((adx>adxx) && (ma>maa) && (sto<20 && rsi<30) && (val>val21))//Signal Buy
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"",MAGICMA,0,Green);
                
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
               OrderModify(ticket,OrderOpenPrice(),Bid-StopLoss,Ask+TakeProfit*Point,0,White); 
        }
      // check for short position (SELL) possibility
      if ((adx<adxx) && (ma<maa) && (sto>80 && rsi>70) && (val<val21))//Signal Sell 
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"",MAGICMA,0,Red);
                
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
               OrderModify(ticket,OrderOpenPrice(),Ask+StopLoss,Bid-TakeProfit*Point,0,White);
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if ((sto>80 && rsi>70) || (adxc<5) || (Open[0]>=StopLoss || Open[0]>=TakeProfit))
                {
                 OrderClose(ticket,OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(ticket,OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if ((sto<20 && rsi<30) || (adxc>5) || (Open[0]>=StopLoss || Open[0]>=TakeProfit))
              {
               OrderClose(ticket,OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(ticket,OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.